<script lang="ts">
import Vue from 'vue';
import { MrktoForm } from '~/components/common/index.vue';

export default Vue.extend({
  name: 'CodeSuggestionsSalesFormWrapper',
  components: { MrktoForm },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    isDark: {
      type: Boolean,
      required: false,
      default: false,
    },
    inTabs: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  methods: {
    onFormSubmit() {
      this.$emit('submit');
    },
  },
});
</script>

<template>
  <div
    class="code-suggestions-sales-form-wrapper"
    :class="{
      'code-suggestions-sales-form-wrapper--dark': isDark,
      'code-suggestions-sales-form-wrapper--tabs': inTabs,
    }"
  >
    <slot> </slot>
    <div
      class="code-suggestions-sales-form-wrapper__blurb"
      :class="{ 'code-suggestions-sales-form-wrapper__blurb--dark': isDark }"
      v-html="$md.render(data.blurb)"
    ></div>
    <MrktoForm
      :data="data"
      class="code-suggestions-sales-form-wrapper__form"
      @submit="onFormSubmit"
    />
  </div>
</template>

<style lang="scss" scoped>
.code-suggestions-sales-form-wrapper {
  border: 1px solid $color-primary-100;
  border-radius: 8px;
  background-color: $color-primary-300;
  padding: $spacing-32;

  :deep .form_column {
    padding: 0 !important;
    margin-bottom: 0 !important;
    .form_container {
      border: 0;
      padding: 0 !important;
      .mktoForm .mktoRequiredField label.mktoLabel {
        text-transform: lowercase !important;
      }

      .mktoHtmlText {
        margin: $spacing-24 0 0 !important;
      }

      .mktoFormCol {
        margin-bottom: 0 !important;
      }

      .mktoForm_container {
        .mktoButtonRow .mktoButtonWrap {
          display: inline-block;

          @media (min-width: $breakpoint-md) {
            margin-left: initial !important;
            width: initial !important;
          }

          button {
            margin-bottom: 0;
          }
        }
        #InstructgitLabSubscriptionName,
        #InstructEmail {
          display: block;
          margin-bottom: 8px;
        }
      }
    }
  }

  &--dark {
    border: 1px solid $color-surface-600;
    background: var(
        --Gradient---vert,
        linear-gradient(
          0deg,
          rgba(225, 152, 109, 0.1) 0%,
          rgba(110, 67, 211, 0.1) 100%
        ),
      ),
      #171321;

    :deep {
      .form_column .form_container {
        padding: 0 !important;
        border: none !important;
        background: none !important;
        color: $color-text-50 !important;
      }

      .mktoForm .mktoRequiredField label.mktoLabel,
      .mktoForm_container .mktoFieldWrap label.mktoLabel,
      .mktoErrorMsg,
      .mktoHtmlText,
      .mktoInstruction,
      .mktoCheckboxList label,
      .mktoFieldWrap.mktoRequiredField span {
        color: $color-text-50 !important;
        padding-left: 0 !important;
      }

      .slp-px-md-32 {
        padding: 0 !important;
      }

      .mktoForm_container a:not(.btn):not(.slp-btn) {
        color: $color-accent-400 !important;
      }

      .mktoButtonRow .mktoButtonWrap button {
        margin-bottom: 0;
        background-color: $color-surface-50 !important;
        color: $color-text-300 !important;

        &:hover {
          background-color: $color-surface-200 !important;
        }
      }

      #InstructgitLabSubscriptionName,
      #InstructEmail {
        display: block;
        margin-bottom: 8px;
      }
    }
  }

  &--tabs {
    padding: $spacing-0;
    border: none;
  }

  &__blurb {
    :deep {
      p:first-of-type strong {
        font-family: 'GitLab Sans';
        font-size: 32px;
        font-style: normal;
        font-weight: 600;
        line-height: 40px;
        letter-spacing: -0.96px;
      }
      .header-anchor {
        display: none;
      }
      p {
        margin: 16px 0;
      }
      blockquote {
        color: $color-surface-500;
        font-family: 'GitLab Sans';
        font-size: 14px;
        font-style: italic;
        font-weight: 400;
        line-height: 20px;
        margin-bottom: 24px;
      }
      sup {
        font-size: 20px;
        font-style: normal;
        font-weight: 600;
        line-height: 24px;
      }
      span.link:hover {
        text-decoration: underline;
      }
    }

    &--dark {
      :deep {
        p:first-of-type strong {
          color: $color-text-50;
        }
      }
      p strong,
      p:first-of-type {
        color: $color-text-50;
      }
      p {
        color: $color-surface-400;
      }
      a {
        color: $color-accent-400;
      }
    }
  }
}
</style>
